package zero1hd.polyjet.ui.windows;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input.Keys;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.scenes.scene2d.ui.List;
import com.badlogic.gdx.scenes.scene2d.ui.ScrollPane;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.Slider;
import com.badlogic.gdx.scenes.scene2d.ui.Window;

import zero1hd.polyjet.entity.Entities;
import zero1hd.polyjet.entity.Entity;
import zero1hd.polyjet.entity.EntityController;
import zero1hd.polyjet.entity.ally.Laser;
import zero1hd.polyjet.entity.enemies.VoidCircle;

public class SpawnerWindow extends Window {
	private EntityController ec;
	private Stage stage;
	
	private List<Entities> listOfEntities;
	private ScrollPane scroller;
	
	private Slider mod1;
	private Slider mod2;
	private Slider mod3;
	public SpawnerWindow(String title, Skin skin, EntityController ec, Stage stageForEntities) {
		super(title, skin);
		this.ec = ec;
		stage = stageForEntities;
		
		mod1 = new Slider(0.1f, 50f, 0.01f, true, skin);
		mod2 = new Slider(0.1f, 15f, 0.01f, true, skin);
		mod3 = new Slider(0.1f, 15f, 0.01f, true, skin);
		
		listOfEntities = new List<>(skin);
		listOfEntities.setItems(Entities.values());
		
		scroller = new ScrollPane(listOfEntities);
		add(scroller).expandY().fillY().spaceRight(15f);
		add(mod1, mod2, mod3);
		
		setSize(300f, 375f);
	}
	
	
	@Override
	public boolean remove() {
		return super.remove();
	}
	
	private Vector2 coords = new Vector2();
	@Override
	public void act(float delta) {
		if (Gdx.input.justTouched() && Gdx.input.isKeyPressed(Keys.SHIFT_LEFT)) {
			coords.set(Gdx.input.getX(), Gdx.input.getY());
			stage.screenToStageCoordinates(coords);
			
			Entity entity;
			if ((entity = ec.retrieveEntity(listOfEntities.getSelected())) != null) {
				switch(entity.getEntityType()) {
				case BAR_BEAT:
					break;
				case LASER:
					Laser laser = (Laser) entity;
					laser.init(coords.x, coords.y, mod1.getValue());
					stage.addActor(laser);
					break;
				case SHARDS:
					break;
				case VOID_CIRCLE:
					VoidCircle voidCircle = (VoidCircle) entity;
					voidCircle.init(mod3.getValue(), coords.x, coords.y, mod1.getValue(), mod2.getValue());
					stage.addActor(voidCircle);
					break;
				default:
					break;
				}
			}
		}
		super.act(delta);
	}
}
